; ARRAY (dato astratto MUTABILE)  
;

;MATRICI PREDEFINITE 

(define a #(#(1 3 5) #(2 4 5) #(1 6 23)))

(define b #(#(-2 1 1) #(1 -2 -2) #(1 1 4)))

(define c #(#(-2 1 1) #(1 -2 -2) #(1 1 4)))

'COSTRUTTORE

(define (matrice x y . init)
    (do ((vec (make-vector y))
             (i 0 (1+ i)))
            ((eq? i y) vec)
            (vector-set! vec i (make-vector x (car init)))))


'SELETTORE

(define (matrice-ref m x y)
        (vector-ref (vector-ref m y) x))

'MUTATORE

(define (matrice-set! m x y el)
        (vector-set! (vector-ref m y) x el) m)


'OPERAZIONI

(define (print-matrice m)
        (do ((i 0 (1+ i)))
            ((= i (vector-length m))) 
            (print (vector-ref m i))))

(define (+matrici m1 m2)   
  (define xmax (xmatrice m1))
  (define ymax (ymatrice m2))
    (define (+mat-it m1 m2 x y)  
      (cond ((= ymax y) m1)
              ((= xmax x) (+mat-it m1 m2 0 (1+ y)))
              (else (sequence (matrice-set! m1 x y (+ (matrice-ref m1 x y)
                                                      (matrice-ref m2 x y))))
                              (+mat-it m1 m2 (1+ x) y))))
   (if (and (= xmax (xmatrice m2))
            (= ymax (ymatrice m1)))
   (+mat-it m1 m2 0 0)
       (quote (dimensioni differenti!))))

(define (*matrici coef m1)
     (define xmax (xmatrice m1))
     (define ymax (ymatrice m1))
     (define (*mat-it m1 x y)
          (cond ((= ymax y) m1)
                ((= xmax x) (*mat-it m1 0 (1+ y)))
                (else (sequence (matrice-set! m1 x y (* coef
                                                        (matrice-ref m1 x y))))
                              (*mat-it m1 (1+ x) y))))
     (*mat-it m1 0 0))
                          
(define (trasposta mat)
        (let* ((xmax (xmatrice mat))
              (ymax (ymatrice mat))
              (m (matrice ymax xmax 0)))
        (define (tr-it x y)
           (cond ((= ymax y) m)
                 ((= xmax x) (tr-it 0 (1+ y)))
                 (else (sequence (matrice-set! m y x (matrice-ref mat x y))
                                 (tr-it (1+ x) y)))))
        (tr-it 0 0)))             

(define (*-rig-col m1 m2)
        (let* ((xmax (xmatrice m2))
              (ymax (ymatrice m1))
              (riga (xmatrice m1))
              (blu (matrice xmax ymax 0)))
        (define (*-it x y)
           (cond ((= ymax y) blu)
                 ((= xmax x) (*-it 0 (1+ y)))
                 (else (sequence (do ((i 0 (1+ i)) 
                                      (ris 0 (+ ris (*(matrice-ref m1 i y)
                                                      (matrice-ref m2 x i)))))
                                     ((= i riga) (matrice-set! blu x y ris)))
                                 (*-it (1+ x) y)))))
          (if (= xmax ymax) 
              (*-it 0 0)
              (quote (dimensioni differenti)))))             

(define (determinante mat)
  (if (not(matrice-quad? mat))
          (error "matrice non quadrata")
      (let ((n (xmatrice mat))
            (ris 0))            
        (cond ((<> n (ymatrice mat)) (quote (non  una matrice quadrata))) 
              ((= n 1) (matrice-ref mat 0 0))            
              ((= n 2) (- (* (matrice-ref mat 0 0) (matrice-ref mat 1 1))
                          (* (matrice-ref mat 0 1) (matrice-ref mat 1 0))))
              ((= n 3) (let ((a11 (matrice-ref mat 0 0))
                             (a12 (matrice-ref mat 0 1))
                             (a13 (matrice-ref mat 0 2))
                             (a21 (matrice-ref mat 1 0))
                             (a22 (matrice-ref mat 1 1))
                             (a23 (matrice-ref mat 1 2))
                             (a31 (matrice-ref mat 2 0))
                             (a32 (matrice-ref mat 2 1))
                             (a33 (matrice-ref mat 2 2)))
                         (- (+ (* a11 a22 a33)(* a12 a23 a31)(* a13 a21 a32))
                            (+ (* a13 a22 a31) (* a11 a23 a32)
                               (* a12 a21 a33))))) 
              (else (do ((i 0 (1+ i)))
                        ((= i n) ris) 
                        (let ((k (matrice-ref mat i 0)))
                          (cond ((= 0 k) i)
                                ((even? i) (set! ris (+ ris (* k            
                                                               (determinante
                                                                 (complemento2
                                                                   mat i))))))
                             ((odd? i) (set! ris (- ris (* k
                                (determinante(complemento2 mat i))))))))))))))
(define (ymatrice m)
        (vector-length m))

(define (xmatrice m)
        (vector-length (vector-ref m 0)))
 
(define (colonna n m1)
        (vector-ref m1 (1+ n)))

(define (matrice-quad? m)
  (if (= (xmatrice m) (ymatrice m))
      #t
      ()))

(define (complemento mat xn yn)
  (if (not (matrice-quad? mat))
      (error "Matrice non Quadrata")
      (let* ((xmax (-1+ (xmatrice mat)))
             (ymax (-1+ (ymatrice mat)))
             (m (matrice xmax ymax 0))
             (xm (-1+ xn))
             (ym (-1+ yn))) 
          (define (tr-it x y x1 y1)
            (cond ((= y ymax) m)
                  ((= x xmax) (tr-it 0 (1+ y) 0 (1+ y1)))
                  ((= x1 xm) (tr-it x y (1+ x1) y1))
                  ((= y1 ym) (tr-it x y x1 (1+ y1)))
                  (else(sequence(matrice-set! m x y(matrice-ref mat x1 y1))
                                (tr-it (1+ x) y (1+ x1) y1)))))
        (tr-it 0 0 0 0))))             

(define (complemento2 mat xn)
  (if (not (matrice-quad? mat))      
  (error "Matrice non Quadrata")
  (let* ((xmax (-1+ (xmatrice mat)))
              (ymax (-1+ (ymatrice mat)))
              (m (matrice xmax ymax 0))) 
          (define (tr-it x y x1 y1)
             (cond ((= y ymax) m)
                   ((= x xmax) (tr-it 0 (1+ y) 0 (1+ y1)))
                   ((= x1 xn) (tr-it x y (1+ x1) y1))
                   (else 
                     (sequence (matrice-set! m x y (matrice-ref mat x1 y1)))
                                   (tr-it (1+ x) y (1+ x1) y1))))
        (tr-it 0 0 0 1))))
             
(define (inversa m)
  (if (not (matrice-quad? m))
      (error "Matrice non Quadrata")
      (let* ((n (xmatrice m))            
            (det (determinante m))    
            (mat (matrice n n 0)))
        (do ((y 0 (1+ y)))                             
            ((= n y) mat)
            (do ((x 0 (1+ x)))
                ((= n x) ()) 
                (cond ((odd? (+ x y)) (matrice-set! mat
                                                    x
                                                    y
                                                    (* (/ -1 det)
                                                       (determinante
                                                         (complemento 
                                                           (copy m)
                                                           (1+ y)
                                                           (1+ x))))))
                (else (matrice-set! mat
                                    x
                                    y
                                    (* (/ 1 det)
                                       (determinante
                                         (complemento (copy m)
                                                      (1+ y)
                                                      (1+ x))))))))))))


'PREDICATO

(define (eq-arr? a b)
  (let ((xmax (xmatrice a))
        (ymax (ymatrice a)))
     (define (eq-it x y) 
    (cond ((= y ymax) #t)
          ((= x xmax) (eq-it 0 ( 1+ y )))
          ((eq? (matrice-ref a x y) (matrice-ref b x y))
           (eq-it (1+ x ) y ))
           (else () )))
    (if (and (= xmax (xmatrice b)) (= ymax (ymatrice b)) )
        (eq-it 0 0)
        ())))
    






