;MATRICE (dato astratto FUNZIONALE)   
;

'SELETTORI

(define (array-ref m x y)
        (list-ref (list-ref m y) x))

'COSTRUTTORI

(define (make-array x y . init)
        (define (array-it y l1)
            (if (= y 0) () (cons l1 (array-it (-1+ y) l1))))
                 (array-it y (make-riga x (car init) )))

(define (make-riga x init)
	    (if (= x 0)
		()
		(cons init (make-riga (-1+ x) init))))

(define (list-entry l x el)
	(cond 	((null? l) ())
                ((= 0 x) (cons el (list-entry (cdr l) (-1+ x) el)))
                (else (cons (car l) (list-entry (cdr l) (-1+ x) el)))))

(define (array-entry m x y el)
        (define (array-entry-it l y )
        	(cond ((null? l) () )
        	      ((= 0 y) (cons (list-entry (car l) x el)
        	      		     (array-entry-it (cdr l) (-1+ y))))
        	      (else (cons (car l)
        	                  (array-entry-it (cdr l) (-1+ y))))))
        (array-entry-it m y))

(define (print-array m)
        (do ((i 0 (1+ i)))
            ((= i (length m)))
            (print (list-ref m i))))

;MATRICI PRECOSTRUITE

(define a (make-array 2 3 4))

(define b (make-array 2 3 5))

(define c '((1 2 3 4) (1 0 1 2) (3 -1 -1 0) (1 2 0 -5)))

'OPERAZIONI

(define (+array m1 m2)
    (define xmax (xarray m1))
    (define ymax (yarray m2))
    (define (+mat-it m1 m2 x y)
        (cond ((= ymax y) m1)
              ((= xmax x) (+mat-it m1 m2 0  (1+ y)))
              (else (+mat-it (array-entry m1 x y
              			(+ (array-ref m1 x y)(array-ref m2 x y)))
              		     m2
                             (1+ x)
                             y))))
    (+mat-it m1 m2 0 0 ))

(define (*array coef m1)
     (define xmax (xarray m1))
     (define ymax (yarray m1))
     (define (*mat-it m1 x y)
          (cond ((= ymax y) m1)
                ((= xmax x) (*mat-it m1 0 (1+ y)))
                (else (*mat-it (array-entry m1 x y
                			(* coef (array-ref m1 x y)))
                               (1+ x) y))))
     (*mat-it m1 0 0))

(define (trasposta mat)
        (let* ((xmax (xarray mat))
              (ymax (yarray mat))
              (m (make-array ymax xmax 0)))
        (define (tr-it m x y)
           (cond ((= ymax y) m)
                 ((= xmax x) (tr-it m 0 (1+ y)))
                 (else (tr-it
                         (array-entry m y x (array-ref mat x y))
                         (1+ x)
                          y))))
        (tr-it m 0 0)))

(define (*-rig-col m1 m2)
        (let* ((xmax (xarray m2))
              (ymax (yarray m1))
              (riga (xarray m1))
              (m (make-array xmax ymax 0)))
        (define (accumula ris i x y)
                (if (= i riga) ris
                    (accumula (+ ris (* (array-ref m1 i y)
                                        (array-ref m2 x i)))
                              (1+ i)
                               x
                               y)))
        (define (*-it m x y)
           (cond ((= ymax y) m)
                 ((= xmax x) (*-it m 0 (1+ y)))
                 (else (*-it (array-entry m x y (accumula 0 0 x y))
                             (1+ x)
                              y))))
        (*-it m 0 0)))


(define (determinante mat)
  (define (accumula ris i mat )
    (if (= i (xarray mat)) 
        ris
        (cond ((= 0 (array-ref mat i 0)) ())
              ((even? i ) 
               (accumula 
                 ( + ris (* (array-ref mat i 0) 
                          (determinante (complemento2 mat i)))) (1+ i) mat))
            ((odd? i)
             (accumula
             (- ris (* (array-ref mat  i 0) 
                       (determinante (complemento2 mat i)))) (1+ i) mat))))) 
  (if (not (matrice-quad? mat))
      (error "matrice non quadrata")
      (let ((n (xarray mat)))
       (cond ((= n 1) (array-ref mat 0 0))
             ((= n 2) (- (* (array-ref mat 0 0) (array-ref mat 1 1))
                         (* (array-ref mat 0 1) (array-ref mat 1 0))))
             ((= n 3) (let ((a11 (array-ref mat 0 0))
                            (a12 (array-ref mat 0 1))
                            (a13 (array-ref mat 0 2))
                            (a21 (array-ref mat 1 0))
                            (a22 (array-ref mat 1 1))
                            (a23 (array-ref mat 1 2))
                            (a31 (array-ref mat 2 0))
                            (a32 (array-ref mat 2 1))
                            (a33 (array-ref mat 2 2)))
                            (- (+ (* a11 a22 a33) 
                                  (* a12 a23 a31) 
                                  (* a13 a21 a32))
                               (+ (* a13 a22 a31) 
                                  (* a11 a23 a32) (* a12 a21 a33)))))
             (else (accumula 0 0 mat))))))

(define (yarray m)
        (length m))

(define (xarray m)
        (length (list-ref m 0)))

(define (colonna n m1)
        (vector-ref m1 (1+ n)))

(define (rc n a b x y1 ris)
        (if (< n 0) ris
            (rc (-1+ n) a b x y1 (+ ris (* (array-ref a n y1)
                                           (array-ref b x n))))))

(define (complemento mat xn yn)
  (if (not (matrice-quad? mat))
      (error "Matrice non quadrata")
  (let* ((xmax (-1+ (xarray mat)))
              (ymax (-1+ (yarray mat)))
              (m (make-array xmax ymax 0))
              (xm (-1+ xn))
              (ym (-1+ yn)))
          (define (tr-it m x y x1 y1)
             (cond ((= y ymax) m)
                   ((= x xmax) (tr-it m 0 (1+ y) 0 (1+ y1)))
                   ((= x1 xm) (tr-it m x y (1+ x1) y1))
                   ((= y1 ym) (tr-it m x y x1 (1+ y1)))
                   (else (tr-it (array-entry m x y (array-ref mat x1 y1))
                                (1+ x)
                                y 
                                (1+ x1) 
                                y1))))
        (tr-it m 0 0 0 0 ))))

(define (complemento2 mat xn)
  (if (not (matrice-quad? mat))
      (error "Matrice non Quadrata")
        (let* ((xmax (-1+ (xarray mat)))
              (ymax (-1+ (yarray mat)))
              (m (make-array xmax ymax 0)))
          (define (tr-it m x y x1 y1)
             (cond ((= y ymax) m)
                   ((= x xmax) (tr-it m 0 (1+ y) 0 (1+ y1)))
                   ((= x1 xn) (tr-it m x y (1+ x1) y1))
                   (else (tr-it (array-entry m x y (array-ref mat x1 y1))
                                (1+ x) 
                                y 
                                (1+ x1) 
                                y1))))
        (tr-it m 0 0 0 1))))

(define (inversa mat)
  (define (inversa-it old-mat new-mat x y det n)
    (cond ((= n y) new-mat)
          ((= n x) (inversa-it old-mat new-mat 0 (1+ y) det n))
          ((odd? (+ x y))
           (inversa-it old-mat
                       (array-entry new-mat
                                    x
                                    y
                                    (* (/ -1 det)
                                       (determinante
                                         (complemento old-mat 
                                                      (1+ y) (1+ x)))))
                       (1+ x)
                       y
                       det
                       n))
          (else (inversa-it old-mat
                            (array-entry new-mat
                                         x
                                         y
                                         (* (/ 1 det)
                                            (determinante
                                              (complemento old-mat 
                                                           (1+ y) (1+ x)))))
                            (1+ x)
                            y
                            det
                            n))))
  
  (let* ((n (xarray mat))
         (m1 (make-array n n 0)))
    (cond ((= n 1) (array-entry m1 0 0 (/ 1 (array-ref mat 0 0))))
          (else (inversa-it mat m1 0 0 (determinante mat) n)))))

'PREDICATI

(define (eq-arr? a b)
  (let ((xmax (xarray a))
        (ymax (yarray a)))
    (define (eq-it x y)
      (cond ((= y ymax) #t)
            ((= x xmax) (eq-it 0 ( 1+ y )))
            ((eq? (array-ref a x y) (array-ref b x y))
             (eq-it (1+ x) y))
            (else () )))
    (if (and ( = xmax (xarray b)) (= ymax (yarray b)) )
        (eq-it 0 0)
        () )))

(define (matrice-quad? m)
  (if (= (xarray m) (yarray m))
      #t 
      () ))





